DROP TABLE IF EXISTS T1 ;
CREATE TEMPORARY TABLE T1
SELECT 
       main.id,
       main.department as '',
       main.place  as '', 
       main.name as ' ',
       main.inn as '.  ',
       main.date as '   ',
       main.holder as '',
       comp.os as '',
       comp.installdate as ' ',
       comp.mb as ' ',
       comp.releasedate as ' . ',
       cpu.name as '',
       cpu.numberofcores as '',
       cpu.socket as '',
       comp.totalmemory as '(Kb)',
       sum(disk.size)/count(*) as '(Gb)',
       ethernet.ipadress as 'ip-',
       GROUP_CONCAT(compprinter.name )as '',
       GROUP_CONCAT(compprinter.port )
             as ' ',
       GROUP_CONCAT(compprinter.defp ) 
              as '  ',
       '' as '.  ',
       '' as ' ',
       main.recdate as ''
FROM 
           main LEFT JOIN compprinter ON
           (main.id=compprinter.id ),
           comp,disk,cpu,ethernet
WHERE (main.id=comp.id)AND
      (main.id=disk.id)AND
      (main.id=cpu.id)AND
      (main.id=ethernet.id)AND
(
 (ethernet.ipadress LIKE "%192.168.88.%")OR
 (ethernet.ipadress LIKE "%10.20.112.%")OR
 (ethernet.ipadress LIKE "%10.20.1.%")OR
 (ethernet.ipadress LIKE "%192.168.1.%")OR
 (ethernet.ipadress LIKE "%192.168.3.%")
)
Group by disk.id
ORDER BY 
      main.department,
      main.place, 
      comp.os,
      cpu.name,
      comp.totalmemory
;

SELECT 
      T1.*,
       GROUP_CONCAT(compmonitor.Model ) as ' ',
       GROUP_CONCAT(compmonitor.ManufacturerID ) as ' 
',
       GROUP_CONCAT(compmonitor.DeviceID ) as ' ',
       GROUP_CONCAT(compmonitor.SerialNumber ) as '.  ',
       GROUP_CONCAT(compmonitor.InvNumber ) as '.  ',
       GROUP_CONCAT(compmonitor.Date ) as ' '
FROM 
           T1 LEFT JOIN compmonitor ON
             T1.id=compmonitor.id 
Group by T1.id
ORDER BY 
      T1.,
      T1., 
      T1.;

DROP TABLE T1;
